import '../../../base/token.dart';

const DynamicToken TAG = DynamicToken('TAG');
const DynamicToken Tstart = DynamicToken('T.start');
const DynamicToken Tend = DynamicToken('T.end');
const DynamicToken endT = DynamicToken('end.T');
const DynamicToken closeT = DynamicToken('close.T');
const DynamicToken Attr = DynamicToken('Attr');
const DynamicToken Vstart = DynamicToken('V.start');
const DynamicToken Vend = DynamicToken('V.end');
const DynamicToken ValuePart = DynamicToken('Value.part');

DynamicToken BLANK = DynamicToken.from(Token.Text);

/// states
const NodeRootState = 'root_node';
const RootTagConstants = 'root_tag_constants';

/// constants & enums
const BlockQuote = 'blockquote';
const HeadLine = 'headline';
const Paragraph = 'p';
const Common = 'common';
const Head1 = 'h1';
const Head2 = 'h2';
const Head3 = 'h3';
const Head4 = 'h4';
const Head5 = 'h5';
const Head6 = 'h6';
const Builder = 'builder';
const Wrapper = 'wrapper';
const Divider = 'divder';
