import 'package:lexpro_nullsafety/lexers/example/dsl/remote_command_line.dart';
import 'package:test/test.dart';

void main() {
  print(RemoteCommandLine().pretty('clear\n'
      'whoami        \n'
      'cd name/is/jack\n'
      'which vim\n'));

  ///CMD.Single(clear)ExecSymbol(\n)
  ///CMD.Single(whoami)        ExecSymbol(\n)
  ///CMD.Path(cd) RltvPath(name/is/jack)ExecSymbol(\n)
  ///CMD.CmmdName(which) NAME.Commands(vim)ExecSymbol(\n)
  ///
  group('Lexer/DSL: DartLibrary with HeadLexer', () {
    test('', () {
      expect(
          RemoteCommandLine().pretty('clear\n'
              'whoami        \n'
              'cd name/is/jack\n'
              'which vim\n'),
          equals('''CMD.Single(clear)ExecSymbol(\\n)
CMD.Single(whoami)        ExecSymbol(\\n)
CMD.Path(cd) RltvPath(name/is/jack)ExecSymbol(\\n)
CMD.CmmdName(which) NAME.Commands(vim)ExecSymbol(\\n)
'''));
    });
  });
}
